package hu.kozadat.search.base;

import hu.kozadat.search.ui.TemplateBasedRenderer;
import hu.kozadat.search.ws.ElementItem;
import hu.kozadat.search.ws.SearchResultItem;
import hu.kozadat.search.model.ResultItem;
import hu.scriptum.mdc.datatype.MDcItem;
import hu.scriptum.nda.api.MDcSearch;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.servlet.http.HttpServletResponse;
import java.util.*;

/**
 * Created by IntelliJ IDEA.
 * User: codex
 * Date: Mar 2, 2008
 * Time: 3:25:22 PM
 * To change this template use File | Settings | File Templates.
 */
@Deprecated
public class BaseSearchUtils {

    private final static Logger LOGGER = LoggerFactory.getLogger(BaseSearchUtils.class);

    public static Map performSimpleSearch(MDcSearch searchService,
                                          String searchExpr,
                                          int maxResultCount,
                                          TemplateBasedRenderer templateRenderer,
                                          String sessionId,
                                          HttpServletResponse response) {
        Map returnValue = new HashMap();

        long time = System.currentTimeMillis();
        int resultNum = 0;
        try {
            resultNum = searchService.executeQuery(sessionId, searchExpr);
        } catch (Exception e) {
            LOGGER.error("Simple search failed: " + e.getMessage(), e);
        }

        returnValue.put("resultSize", new Integer(resultNum));
        long queryElapsedTime = System.currentTimeMillis() - time;
        returnValue.put("queryElapsedTime", new Long(queryElapsedTime));
        time = System.currentTimeMillis();

        List<ResultItem> resultList = new LinkedList<ResultItem>();
        Set<Long> dataProvidersProcessed = new HashSet<Long>();
        Map<Long, List<ResultItem>> dataProviderResults = new HashMap<Long, List<ResultItem>>();
        Map<Long, Integer> dataProviderIds = new HashMap<Long, Integer>();
        int globalId = 0;
        if (resultNum > 0) {
            String[] hits = searchService.getHits(sessionId, 0,
                    resultNum < maxResultCount ? resultNum : maxResultCount);

            for (int i = 0; i < hits.length; i++) {
                LOGGER.debug("hit: " + hits[i]);
                ResultItem tmpItem = templateRenderer.getResultItemFor(hits[i], 0, response);

                //-- check if this is a new dp
                if (dataProvidersProcessed.contains(tmpItem.getDataProviderId())) {
                    List<ResultItem> dpResultList = dataProviderResults.get(tmpItem.getDataProviderId());
                    Integer dpId = dataProviderIds.get(tmpItem.getDataProviderId());

                    ResultItem moreRecordsItem = templateRenderer.getResultItemFor(hits[i], dpId.intValue() + 1, response, TemplateBasedRenderer.TEMPLATE_TEXT_SEARCH_MORERECORDS);
                    dpResultList.add(moreRecordsItem);

                    dataProviderIds.put(tmpItem.getDataProviderId(), new Integer(dpId + 1));
                } else {
                    ResultItem item = templateRenderer.getResultItemFor(hits[i], globalId + 1, response);
                    resultList.add(item);
                    globalId++;

                    dataProvidersProcessed.add(item.getDataProviderId());

                    int dpId = 0;
                    ResultItem moreRecordsItem = templateRenderer.getResultItemFor(hits[i], dpId + 1, response, TemplateBasedRenderer.TEMPLATE_TEXT_SEARCH_MORERECORDS);
                    dpId++;

                    dataProviderIds.put(item.getDataProviderId(), new Integer(dpId));

                    List<ResultItem> dpResultList = new LinkedList<ResultItem>();
                    dpResultList.add(moreRecordsItem);
                    dataProviderResults.put(item.getDataProviderId(), dpResultList);
                }
            }
        }
        long resultProcessTime = System.currentTimeMillis() - time;
        returnValue.put("resultProcessTime", new Long(resultProcessTime));
        returnValue.put("results", resultList);
        returnValue.put("dataProviderResults", dataProviderResults);

        return returnValue;
    }

    public static Collection<SearchResultItem> performWSSimpleSearch(
            MDcSearch searchService,
            String searchExpr,
            int maxResultCount,
            TemplateBasedRenderer templateRenderer,
            String sessionId,
            HttpServletResponse response) {
        Collection<SearchResultItem> ret = new ArrayList<SearchResultItem>();

        int resultNum = 0;
        try {
            resultNum = searchService.executeQuery(sessionId, searchExpr);
        } catch (Exception e) {
            LOGGER.error("WS Simple search failed: " + e.getMessage(), e);
        }

        if (resultNum > 0) {
            String[] hits = searchService.getHits(sessionId, 0, resultNum < maxResultCount ? resultNum : maxResultCount);

            for (int i = 0; i < hits.length; i++) {
                LOGGER.debug("hit: " + hits[i]);
                ResultItem tmpItem = templateRenderer.getResultItemFor(hits[i], 0, response);

                Collection<ElementItem> elementItems = new ArrayList<ElementItem>();
                Iterator iter = tmpItem.getRecord().getItemIterator();
                while (iter.hasNext()) {
                    MDcItem item = (MDcItem) iter.next();
                    String elementName = item.getElementName();
                    String qualifier = item.getQualifier();
                    String value = item.getValue();

                    elementItems.add(new ElementItem(elementName, qualifier, value));
                }

                SearchResultItem actItem = new SearchResultItem(tmpItem.getDataProviderId(), elementItems);
                actItem.setModificationDate(tmpItem.getModificationDate());
                ret.add(actItem);
            }
        }

        return ret;
    }

}
