package hu.kozadat.search.base.preprocessor;

import java.util.*;

/**
 * User: codex
 */
public class DatePrecision {
    private SortedMap<String, Integer> precisionMap;

    public void setPrecisionMap(Map map) {
        SortedMap<String, Integer> res = new TreeMap<String, Integer>();

        for (Object o : map.keySet()) {
            String key = (String) o;
            int intValue = -1;

            try {
                intValue = Integer.parseInt((String) map.get(key));
            } catch (NumberFormatException nex) {
                //-- fall through, the default value (-1) denotes conversion error
            }

            res.put(key, new Integer(intValue));
        }

        this.precisionMap = res;
    }

    private int getDayAdjustment(int year) {
        String key;

        SortedMap<String, Integer> sub = precisionMap.headMap(String.valueOf(year));
        if (sub != null) {
            if (sub.size() > 0)
                key = sub.lastKey();
            else
                key = precisionMap.firstKey();
        } else {
            key = precisionMap.firstKey();
        }

        return precisionMap.get(key).intValue();
    }


    private Date adjustDate(Date event, int sign) {
        GregorianCalendar cal = new GregorianCalendar();
        cal.setTime(event);

        int year = cal.get(Calendar.YEAR);
        int dayAdjust = getDayAdjustment(year);

        cal.add(Calendar.DATE, dayAdjust * sign);

        return cal.getTime();
    }

    public Date adjustDateUpwards(Date event) {
        return adjustDate(event, 1);
    }

    public Date adjustDateDownwards(Date event) {
        return adjustDate(event, -1);
    }
}
