package hu.kozadat.search.base.preprocessor;

/**
 * User: codex
 */
public class InvalidCharPreprocessor extends QueryPreprocessor {

    public static final String INVALID_CHARACTERS = "%!~*?";

    public QueryPreprocessorResult preprocess(String segment, boolean appendFieldName) {
        QueryPreprocessorResult res = new QueryPreprocessorResult();
        res.setOriginalQuery(segment);
        StringBuffer sb = new StringBuffer();

        for (int idx = 0; idx < segment.length(); idx++) {
            String actChar = segment.substring(idx, idx + 1);

            if (INVALID_CHARACTERS.indexOf(actChar) != -1)
                res.getRemovedChars().add(actChar);
            else
                sb.append(actChar);

        }

        res.setFilteredQuery(sb.toString());
        return res;
    }
}
