package hu.kozadat.search.base.preprocessor;

import java.text.SimpleDateFormat;
import java.util.HashMap;
import java.util.Map;

/**
 * User: codex
 */
public abstract class QueryPreprocessor {
    public static final SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");

    public static final String BEFORE_CHRISTMAS = "ie";
    public static final String AFTER_CHRISTMAS = "isz";

    protected static final Map<String, MonthContainer> monthConversionMap;

    static {
        monthConversionMap = new HashMap<String, MonthContainer>();
        monthConversionMap.put("január", new MonthContainer(1, 31));
        monthConversionMap.put("01", new MonthContainer(1, 31));
        monthConversionMap.put("1", new MonthContainer(1, 31));
        monthConversionMap.put("február", new MonthContainer(2, 28));
        monthConversionMap.put("02", new MonthContainer(2, 28));
        monthConversionMap.put("2", new MonthContainer(2, 28));
        monthConversionMap.put("március", new MonthContainer(3, 31));
        monthConversionMap.put("03", new MonthContainer(3, 31));
        monthConversionMap.put("3", new MonthContainer(3, 31));
        monthConversionMap.put("április", new MonthContainer(4, 30));
        monthConversionMap.put("04", new MonthContainer(4, 30));
        monthConversionMap.put("4", new MonthContainer(4, 30));
        monthConversionMap.put("május", new MonthContainer(5, 31));
        monthConversionMap.put("05", new MonthContainer(5, 31));
        monthConversionMap.put("5", new MonthContainer(5, 31));
        monthConversionMap.put("június", new MonthContainer(6, 30));
        monthConversionMap.put("06", new MonthContainer(6, 30));
        monthConversionMap.put("6", new MonthContainer(6, 30));
        monthConversionMap.put("július", new MonthContainer(7, 31));
        monthConversionMap.put("07", new MonthContainer(7, 31));
        monthConversionMap.put("7", new MonthContainer(7, 31));
        monthConversionMap.put("augusztus", new MonthContainer(8, 31));
        monthConversionMap.put("08", new MonthContainer(8, 31));
        monthConversionMap.put("8", new MonthContainer(8, 31));
        monthConversionMap.put("szeptember", new MonthContainer(9, 30));
        monthConversionMap.put("09", new MonthContainer(9, 30));
        monthConversionMap.put("9", new MonthContainer(9, 30));
        monthConversionMap.put("október", new MonthContainer(10, 31));
        monthConversionMap.put("10", new MonthContainer(10, 31));
        monthConversionMap.put("november", new MonthContainer(11, 30));
        monthConversionMap.put("11", new MonthContainer(11, 30));
        monthConversionMap.put("december", new MonthContainer(12, 31));
        monthConversionMap.put("12", new MonthContainer(12, 31));
    }

    public abstract QueryPreprocessorResult preprocess(String segment, boolean appendFieldName);

    protected boolean isLeapYear(int year) {
        boolean leapYear = false;

        if ((year % 4) == 0) {
            if ((year % 100) == 0) {
                if ((year % 400) == 0)
                    leapYear = true;
            } else {
                leapYear = true;
            }
        }

        return leapYear;
    }
}
