package hu.kozadat.search.base.preprocessor;

import java.util.HashSet;
import java.util.Set;

/**
 * User: codex
 */
public class QueryPreprocessorResult {
    private String originalQuery;
    private String filteredQuery;
    private Set<String> removedChars;
    private boolean queryModified;

    public QueryPreprocessorResult(String originalQuery, String filteredQuery, Set<String> removedChars) {
        this.originalQuery = originalQuery;
        this.filteredQuery = filteredQuery;
        this.removedChars = removedChars;
        queryModified = false;
    }

    public QueryPreprocessorResult() {
        removedChars = new HashSet<String>();
        queryModified = false;
    }


    public QueryPreprocessorResult(String query, Set<String> removedChars) {
        this.filteredQuery = query;
        this.removedChars = removedChars;
        queryModified = false;
    }

    public String getOriginalQuery() {
        if (originalQuery == null)
            throw new IllegalStateException("Original query is no set.");

        return originalQuery;
    }

    public void setOriginalQuery(String originalQuery) {
        this.originalQuery = originalQuery;
    }

    public String getFilteredQuery() {
        if (filteredQuery == null)
            throw new IllegalStateException("Filtered query is no set.");

        return filteredQuery;
    }

    public void setFilteredQuery(String filteredQuery) {
        this.filteredQuery = filteredQuery;
    }

    public Set<String> getRemovedChars() {
        return removedChars;
    }

    public String getRemovedCharsAsString() {
        StringBuffer res = new StringBuffer();

        for (String removedChar : removedChars) {
            res.append(removedChar);
        }

        return res.toString();
    }

    public String[] getRemovedCharsAsArray() {
        return removedChars.toArray(new String[removedChars.size()]);
    }

    public void setRemovedChars(Set<String> removedChars) {
        this.removedChars = removedChars;
    }

    public boolean isQueryModified() {
        return queryModified;
    }

    public void setQueryModified(boolean queryModified) {
        this.queryModified = queryModified;
    }
}
