package hu.kozadat.search.base.renderer;

import hu.kozadat.search.model.ResultItem;

/**
 * Jogszabalytervezet semahoz kapcsolodo renderer.
 *
 * @author Csaba Horvath, Scriptum Inc.
 * @version $Id$
 */
@Deprecated
public class MeasurePlanResultListItemRenderer extends AbstractResultListItemRenderer {
    private String type;
    private String format;
    private String openForPublic;

    public MeasurePlanResultListItemRenderer() {
        super();
        setElementConfig("title", "title");
        setElementConfig("keyword", "subject/keyword");
        setElementConfig("creator", "creator");
        setElementConfig("description", "description");
        setElementConfig("date", "date/available");
        setElementConfig("url", "source");
    }

    public void processLine(String key, String qualifier, String value, boolean containsHighlight) {
        if ("type".equals(key) && qualifier.length() == 0 && type == null) {
            type = value;
        } else if ("format".equals(key) && qualifier.length() == 0 && format == null) {
            format = value;
        } else if ("date".equals(key) && "openForPublicOpinion".equals(qualifier) && openForPublic == null) {
            openForPublic = value;
        }
    }

    public String getResultHtmlFragment(ResultItem item, int index) {
        StringBuffer resultHtmlFragmentBuf = new StringBuffer(256);

        String url = getInternalValue("url");
        if (url != null) {
            item.setUrl(url);
        }
        // url = getResponse().encodeURL(getUrlPrefix() + index);

        resultHtmlFragmentBuf.append("<div class=\"title\">");
        if (item.getUrl() != null) {
            resultHtmlFragmentBuf.append("<a href=\"");
            resultHtmlFragmentBuf.append(url);
            resultHtmlFragmentBuf.append("\" target=\"_new\">");
        }
        resultHtmlFragmentBuf.append(getInternalValue("title") == null ?
                "&lt;Nincs c\u00EDm&gt;" : getInternalValue("title"));
        if (item.getUrl() != null) {
            resultHtmlFragmentBuf.append("</a>");
        }
        resultHtmlFragmentBuf.append("</div>");

        resultHtmlFragmentBuf.append("<div class=\"creator\">");
        resultHtmlFragmentBuf.append(getInternalValue("creator") == null ?
                "" : getInternalValue("creator"));
        resultHtmlFragmentBuf.append("</div>");

        resultHtmlFragmentBuf.append("<div class=\"keywords\">");
        if (getInternalValue("keyword") != null) {
            resultHtmlFragmentBuf.append("Kulcsszavak: ");
            resultHtmlFragmentBuf.append(getInternalValue("keyword"));
        }
        resultHtmlFragmentBuf.append("</div>");

        if (getInternalValue("description") != null) {
            resultHtmlFragmentBuf.append("<div class=\"description\">");
            resultHtmlFragmentBuf.append(getInternalValue("description"));
            resultHtmlFragmentBuf.append("</div>");
        }

        resultHtmlFragmentBuf.append("<div class=\"metadataType\">");
        resultHtmlFragmentBuf.append(item.getMetadataType());
        resultHtmlFragmentBuf.append("</div>");

        resultHtmlFragmentBuf.append("<div class=\"published\">");
        resultHtmlFragmentBuf.append("Közzététel ideje: ");
        resultHtmlFragmentBuf.append(getInternalValue("date") == null ?
                " - nincs megadva" : getInternalValue("date"));
        resultHtmlFragmentBuf.append(" - Véleményezhető: ");
        resultHtmlFragmentBuf.append(openForPublic == null ? "" : openForPublic);
        resultHtmlFragmentBuf.append("</div>");

        resultHtmlFragmentBuf.append("<div class=\"resultFooter\">");
        resultHtmlFragmentBuf.append(item.getUrl() == null ? "" :
                "<a href=\"" + url + "\">" + item.getUrl() + "</a>");
        resultHtmlFragmentBuf.append(" - ");
        resultHtmlFragmentBuf.append(type == null ? "" : type);
        resultHtmlFragmentBuf.append(" - ");
        resultHtmlFragmentBuf.append(format == null ? "" : format);
        resultHtmlFragmentBuf.append("</div>");

        type = null;
        format = null;
        openForPublic = null;

        return resultHtmlFragmentBuf.toString();
    }
}
