package hu.kozadat.search.interactive;

import java.util.ArrayList;
import java.util.List;

/**
 * User: codex
 */
public class InteractiveSearchExpression {

    private List<IInteractiveSearchTerm> terms;

    public InteractiveSearchExpression() {
        terms = new ArrayList<IInteractiveSearchTerm>();
    }

    public InteractiveSearchExpression(List<IInteractiveSearchTerm> terms) {
        this.terms = terms;
    }

    public List<IInteractiveSearchTerm> getTerms() {
        return terms;
    }

    public void setTerms(List<IInteractiveSearchTerm> terms) {
        this.terms = terms;
    }

    public String toQueryString() {
        StringBuffer out = new StringBuffer();

        int idx = 0;
        for (IInteractiveSearchTerm term : terms) {
            if (!term.isEmpty()) {
                out.append(term.toQueryFragment(idx == 0));
                idx++;
            }
        }

        if (idx == 0) {
            //-- search is empty, add some default search criteria
            out.append(InteractiveSearchTermUtils.getDefaultSearchTerm().toQueryFragment(idx == 0));
        }

        return out.toString();
    }

    public String toString() {
        if (terms.isEmpty()) {
            return null;
        }

        StringBuilder sb = new StringBuilder("Kereső kifejezés: ");

        boolean first = true;
        for (IInteractiveSearchTerm term : terms) {
            if (!term.isEmpty()) {
                String str = term.toString();
                if (first) {
                    str = str.substring(term.getOperator().length() + 1);
                    first = false;
                }
                sb.append(str);
            }
        }

        return sb.toString();
    }

}
