package hu.kozadat.search.interactive;

import com.actiwise.einfoszab.Utils;
import hu.kozadat.search.Constants;

import java.util.List;

/**
 * User: codex
 */
public class ValuedListSearchTerm implements IInteractiveSearchTerm {
    private String fieldName;
    private List<String> values;
    private String operator;

    public String getFieldName() {
        return fieldName;
    }

    public void setFieldName(String fieldName) {
        this.fieldName = fieldName;
    }

    public List<String> getValues() {
        return values;
    }

    public void setValues(List<String> values) {
        this.values = values;
    }

    public String getOperator() {
        return operator;
    }

    public void setOperator(String operator) {
        this.operator = operator;
    }

    public String toQueryFragment(boolean isFirstTerm) {
        StringBuffer out = new StringBuffer();

        if (values.size() > 1) {
            if (!isFirstTerm) {
                out.append(" ").append(operator).append(" ");
            }

            out.append("( ");

            int idx = 0;
            for (String value : values) {

                out.append(Utils.normalizeFieldName(fieldName.trim())).append(":");

//                if ( Utils.containsWhitespace( value )) {
                out.append("\"").append(value).append("\"");
//                } else {
//                    out.append( value );
//                }

                if (idx != values.size() - 1) {
                    out.append(" vagy ");
                }

                idx++;
            }
            out.append(" ) ");
        } else {
            if (Constants.INTERACTIVE_SEARCH_TERM_OPERATOR_AND.equals(operator.toLowerCase())) {
                out.append("+");
            }

            out.append(Utils.normalizeFieldName(fieldName.trim())).append(":");

//            if ( Utils.containsWhitespace( values.get(0) )) {
            out.append("\"").append(values.get(0)).append("\"");
//            } else {
//                out.append( values.get(0) );
///            }
            out.append(" ");
        }

        return out.toString();
    }

    public boolean isEmpty() {
        return values == null || values.size() == 0;
    }

    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(operator).append(" ").append(fieldName).append("=").append(values).append(" ");
        return sb.toString();
    }

}
