package hu.kozadat.search.persistence;

import hu.scriptum.einfoszab.api.EInfoSzabOperationException;
import hu.scriptum.einfoszab.datamodel.*;

import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * Created with IntelliJ IDEA.
 * User: tnagy
 * Date: 2012.05.24.
 * Time: 12:38
 * To change this template use File | Settings | File Templates.
 */
public interface DataProviderOperations {
    List<DataProvider> getDataProvidersInSettlement(long settlementId);

    List<DataProvider> getDataProvidersInSubRegion(long subRegionId);

    Map<Long, Long> getDataProviderCountInSubRegionsByCounty(long countyId);

    Map<Long, Long> getDataProviderCountInSubRegionsByRegion(long regionId);

    List<DataProvider> getDataProvidersInCounty(long countyId);

    SubRegion getSubRegion(long subRegionId);

    List<SubRegion> getSubRegionsInCounty(long countyId);

    List<SubRegion> getSubRegionsInRegion(long regionId);

    Region getRegion(Long regionId);

    List<Region> getRegions();

    County getCounty(Long countyId);

    void setDefaultProviderPriority(int defaultProviderPriority);

    void addDataProvider2(DataProvider dataProvider) throws EInfoSzabOperationException;

    void addDPPhones(DataProvider dp);

    int deleteDPPhones(long dpId);

    void addInstitutionTypes(DataProvider dp);

    int deleteInstitutionTypes(long dpId);

    List<Integer> getInstitutionTypeIds(List<String> types);

    void addDataProvider(DataProvider dataProvider) throws EInfoSzabOperationException;

    DataProvider getDataProvider(long id) throws EInfoSzabOperationException;

    void deleteDataProvider(DataProvider dataProvider) throws EInfoSzabOperationException;

    void saveDataProviderChanges(DataProvider provider) throws EInfoSzabOperationException;

    void sendActivityRequest(DataProvider provider) throws EInfoSzabOperationException;

    void sendDeleteRequest(DataProvider provider) throws EInfoSzabOperationException;

    String getOaiRepositoryConfigurationXml(DataProvider provider) throws EInfoSzabOperationException;

    List getSupportedSchemas();

    List getDefaultSchemas();

    void setDefaultSchemaIds(Set defaultSchemaIds);

    List getUserTypes();

    int getActiveRecordCount(DataProvider provider);

    void addUserType(String type) throws EInfoSzabOperationException;

    void removeUserType(long id) throws EInfoSzabOperationException;

    long getDataProviderId(String name) throws EInfoSzabOperationException;

    String getDataProviderName(long dataProviderId);

    String getDataProviderOaiId(long dataProviderId);

    List<InstitutionType> getInstitutionTypes();

    List getDPPhones(long dataProviderId);

    List getUserPhones(String loginName);

    List getUserEmails(String loginName);

    List getInstitutionTypes(long dataProviderId);

    int updateInstitutionData(DataProvider dp);

    int updateOaiData(DataProvider dp);

    int updateHarvestInterval(long dataProviderId, int harvestInterval);

    String getHarvestURL(long dataproviderId);

    Address getAddress(long dataProviderId);

    ZipCode getZipCode(long zipCodeSettlementId);

    List<ZipCode> getZipCodes();

    List<ZipCode> getZipCodesByPattern(String pattern);

}
