package hu.kozadat.search.persistence.core;

import hu.kozadat.search.model.InstitutionNameAutoCompleteData;
import hu.kozadat.search.model.InstitutionNameAutoCompleteDataStatusType;
import hu.scriptum.einfoszab.datamodel.DataProvider;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.jdbc.core.RowMapper;

import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * Created with IntelliJ IDEA.
 * User: tnagy
 * Date: 2012.07.04.
 * Time: 16:19
 */
public class InstitutionNameAutoCompleteDataMapper implements RowMapper<InstitutionNameAutoCompleteData> {

    private static final Logger LOGGER = LoggerFactory.getLogger(InstitutionNameAutoCompleteDataMapper.class);

    protected Long getLongIfExists(String columnName, ResultSet resultSet) throws SQLException {
        try {
            return resultSet.getLong(columnName);
        } catch (Exception e) {
            // LOGGER.warn("error reading column '" + columnName + "' as Long, " + e.getMessage());
        }
        return null;
    }

    protected String getStringIfExists(String columnName, ResultSet resultSet) throws SQLException {
        try {
            return resultSet.getString(columnName);
        } catch (Exception e) {
            // LOGGER.warn("error reading column '" + columnName + "' as String, " + e.getMessage());
        }
        return null;
    }

    public InstitutionNameAutoCompleteData mapRow(ResultSet resultSet, int i) throws SQLException {

//        Long statusOrder = getLongIfExists("status_ord", resultSet);
//        LOGGER.info("mapRow(): statusOrder={}", statusOrder);

        InstitutionNameAutoCompleteData data = new InstitutionNameAutoCompleteData();

        // tnagy set default
        data.setStatus(InstitutionNameAutoCompleteDataStatusType.OTHER.getJsonValue());

        data.setId(getLongIfExists("id", resultSet));
        data.setLabel(getStringIfExists("label", resultSet));

        String dbStatus = getStringIfExists("status", resultSet);

        if (DataProvider.STATE_ACTIVE.equals(dbStatus)) {
            data.setStatus(InstitutionNameAutoCompleteDataStatusType.ACTIVE.getJsonValue());
        } else if (DataProvider.STATE_REGISTERED.equals(dbStatus)) {
            data.setStatus(InstitutionNameAutoCompleteDataStatusType.REGISTERED.getJsonValue());
        } else if (DataProvider.STATE_ARCHIVED.equals(dbStatus)) {
            data.setStatus(InstitutionNameAutoCompleteDataStatusType.ARCHIVED.getJsonValue());
        }

        return data;
    }
}
