package hu.kozadat.search.persistence.impl;

import hu.kozadat.search.persistence.DictionaryOperations;
import hu.kozadat.search.persistence.recommendedsearch.RdbmsDictionarySource;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.Map;

/**
 * Created with IntelliJ IDEA.
 * User: tnagy
 * Date: 2012.05.24.
 * Time: 12:20
 * To change this template use File | Settings | File Templates.
 */
@Repository("dictionaryOperations")
public class DictionaryOperationsImpl implements DictionaryOperations {

    private static final Logger LOGGER = LoggerFactory.getLogger(DictionaryOperationsImpl.class);

    private JdbcTemplate jdbcTemplate;
    private RdbmsDictionarySource rdbmsDictionarySource;

    @Autowired
    public void setJdbcTemplate(JdbcTemplate jdbcTemplate) {
        this.jdbcTemplate = jdbcTemplate;
        this.rdbmsDictionarySource = new RdbmsDictionarySource();
        this.rdbmsDictionarySource.setJdbcTemplate(this.jdbcTemplate);
    }

    public Map<String, String> readCriticalWords() {
        return rdbmsDictionarySource.readCriticalWords();
    }

    public Map<String, String> readSubstituteWords() {
        return rdbmsDictionarySource.readSubstituteWords();
    }

    public Map<String, String> readWords(long type) {
        return rdbmsDictionarySource.readWords(type);
    }
}
