package hu.kozadat.search.presentation.simplesearch;


import hu.scriptum.einfoszab.datamodel.Schema;

import java.util.List;

/**
 * Az egyszeru keresos informacioit tartalmazo adat bean.
 *
 * @author Csaba Horvath, Scriptum Inc.
 * @version $Id$
 */
public class SimpleSearchFormBackingBean {

    public static final String SCHEMA_PREFIX_KOZADAT_ADATBAZIS = "kozadat_adatbazis";
    public static final String SCHEMA_PREFIX_KOZADAT_ALTALANOS = "kozadat_altalanos";
    public static final String SCHEMA_PREFIX_KOZADAT_JOGSZABALYTERVEZET = "kozadat_jogszabalytervezet";
    public static final String SCHEMA_PREFIX_KOZADAT_KOZLONY = "kozadat_kozlony";
    public static final String SCHEMA_PREFIX_KOZADAT_OGY_TVJAVASLAT = "kozadat_OGY_tvjavaslat";

    // page
    private int oldal = 0;

    // search expression
    private String szoveg;

    // selected schema ids
    private List<String> sema;
    private List<Schema> availableSchemas;

    private Long dataProviderId;
    private String dataProviderName;

    public String getSzoveg() {
        return szoveg;
    }

    public void setSzoveg(String szoveg) {
        this.szoveg = szoveg;
    }

    public List<String> getSema() {
        return sema;
    }

    public void setSema(List<String> sema) {
        this.sema = sema;
    }

    public List<Schema> getAvailableSchemas() {
        return availableSchemas;
    }

    public void setAvailableSchemas(List<Schema> availableSchemas) {
        this.availableSchemas = availableSchemas;
    }

    public int getOldal() {
        return oldal;
    }

    public void setOldal(int oldal) {
        this.oldal = oldal;
    }

    public Long getDataProviderId() {
        return dataProviderId;
    }

    public void setDataProviderId(Long dataProviderId) {
        this.dataProviderId = dataProviderId;
    }

    public String getDataProviderName() {
        return dataProviderName;
    }

    public void setDataProviderName(String dataProviderName) {
        this.dataProviderName = dataProviderName;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        SimpleSearchFormBackingBean that = (SimpleSearchFormBackingBean) o;

        if (dataProviderId != null ? !dataProviderId.equals(that.dataProviderId) : that.dataProviderId != null)
            return false;
        if (sema != null ? !sema.equals(that.sema) : that.sema != null) return false;
        if (szoveg != null ? !szoveg.equals(that.szoveg) : that.szoveg != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = szoveg != null ? szoveg.hashCode() : 0;
        result = 31 * result + (sema != null ? sema.hashCode() : 0);
        result = 31 * result + (dataProviderId != null ? dataProviderId.hashCode() : 0);
        return result;
    }
}
