package hu.kozadat.search.presentation.simplesearch;

import org.springframework.validation.Errors;
import org.springframework.validation.Validator;

/**
 * @author Csaba Horvath, Scriptum Inc.
 * @version $Id$
 */
public class SimpleSearchValidator implements Validator {
    private int searchTextMinLength;
    private int searchTextMaxLength;

    public SimpleSearchValidator() {
        searchTextMinLength = 0;
        searchTextMaxLength = 512;
    }

    public int getSearchTextMaxLength() {
        return searchTextMaxLength;
    }

    public void setSearchTextMaxLength(int searchTextMaxLength) {
        this.searchTextMaxLength = searchTextMaxLength;
    }

    public int getSearchTextMinLength() {
        return searchTextMinLength;
    }

    public void setSearchTextMinLength(int searchTextMinLength) {
        this.searchTextMinLength = searchTextMinLength;
    }

    public boolean supports(Class clazz) {
        return true;

    }

    public void validate(Object o, Errors errors) {
        if (o instanceof SimpleSearchFormBackingBean) {
            SimpleSearchFormBackingBean form = (SimpleSearchFormBackingBean) o;

            if (form.getSzoveg() == null || form.getSzoveg().trim().length() < searchTextMinLength) {
                errors.rejectValue("szoveg", "validation.form.search.expression_too_short");
            } else if (form.getSzoveg().trim().length() > searchTextMaxLength) {
                errors.rejectValue("szoveg", "validation.form.search.expression_too_long");
            }
        }
    }

}
