package hu.kozadat.search.service.log;

import com.actiwise.einfoszab.logcentral.client.LogCentralClient;
import com.actiwise.einfoszab.logcentral.client.LogCentralClientException;
import hu.kozadat.search.exception.LogCentralClientServiceException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.jms.ConnectionFactory;
import javax.jms.Destination;
import java.util.Date;

/**
 * Created with IntelliJ IDEA.
 * User: tnagy
 * Date: 2012.05.22.
 * Time: 13:50
 * To change this template use File | Settings | File Templates.
 */
@Service("logCentralClientService")
public class LogCentralClientService {

    private static final Logger LOGGER = LoggerFactory.getLogger(LogCentralClientService.class);

    private ConnectionFactory jmsConnectionFactory;
    private Destination logCentralDestination;
    private LogCentralClient logCentralClient;

    public LogCentralClientService() {
        LOGGER.info("Creating LogCentralClientService...");
        LOGGER.info("LogCentralClientService created.");
    }

    @Autowired
    public void setJmsConnectionFactory(ConnectionFactory jmsConnectionFactory) {
        this.jmsConnectionFactory = jmsConnectionFactory;
    }

    @Autowired
    public void setLogCentralDestination(Destination logCentralDestination) {
        this.logCentralDestination = logCentralDestination;
    }

    protected LogCentralClient getClient() throws LogCentralClientException {
        if (logCentralClient == null) {
            synchronized (this) {
                if (logCentralClient == null) {
                    logCentralClient = new LogCentralClient(jmsConnectionFactory, logCentralDestination);
                }
            }
        }
        return logCentralClient;
    }

    public void sendMessage(String message) {

    }

    public void sendMessage(String module, String eventType, String event, String user, String dataProvider, Date time, String details) throws LogCentralClientServiceException {
        try {
            getClient().sendMessage(module, eventType, event, user, dataProvider, time, details);
        } catch (LogCentralClientException e) {
            throw new LogCentralClientServiceException(e.getMessage() ,e);
        }
    }
}
