/**
 * Created by IntelliJ IDEA.
 * User: tnagy
 * Date: 2010.02.17.
 * Time: 10:06:20
 */
package hu.kozadat.search.service.searchstatistic;

import hu.kozadat.search.persistence.StatisticOperations;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class SearchStatisticService {

    private StatisticOperations statisticOperations;

    @Autowired
    public void setStatisticOperations(StatisticOperations statisticOperations) {
        this.statisticOperations = statisticOperations;
    }

    public void storeQuery(String searchExpression) {
        if (searchExpression != null) {
            String normalizedSearchExpression = searchExpression.toLowerCase().trim().replaceAll("\\s+", " ");
            statisticOperations.updateOrInsertSearchQuery(normalizedSearchExpression);
        }
    }

    public List<String> getPrevalentSearches(int count) {
        return statisticOperations.getPrevalentSearchExpressions(count);
    }

    public List<String> getRandomPrevalentSearches(int count, int randomInterval) {
        return statisticOperations.getRandomPrevalentSearchExpressions(count, randomInterval);
    }
}
