/**
 * Created by IntelliJ IDEA.
 * User: tnagy
 * Date: 2010.05.05.
 * Time: 1:11:29
 */
package hu.kozadat.search.web;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletRequestWrapper;
import java.util.Collections;
import java.util.Enumeration;
import java.util.Map;

public class SearchUIHttpServletRequestWrapper extends HttpServletRequestWrapper {

    private final Map<String, String[]> parameters;

    public SearchUIHttpServletRequestWrapper(HttpServletRequest httpServletRequest, Map<String, String[]> parameters) {
        super(httpServletRequest);
        this.parameters = parameters;
    }

    @Override
    public String getParameter(String name) {
        String[] values = this.parameters.get(name);
        return (values != null && values.length != 0) ? values[0] : null;
    }

    @Override
    public Map getParameterMap() {
        return Collections.unmodifiableMap(this.parameters);
    }

    @Override
    public Enumeration getParameterNames() {
        return Collections.enumeration(this.parameters.keySet());
    }

    @Override
    public String[] getParameterValues(String name) {
        return this.parameters.get(name);
    }
}
